package b4x.example.sibs;

import anywheresoftware.b4a.BA;
import anywheresoftware.b4a.BA.*;
import android.app.Activity;
import android.content.Context;
import android.os.AsyncTask;
import android.util.Log;
import android.content.Intent;
import android.util.Base64;
import android.os.Bundle;

//import android.support.v4.app.TaskStackBuilder;
import androidx.core.app.TaskStackBuilder;

import android.app.NotificationManager;
import java.util.ArrayList;
import java.util.List;

import java.util.HashMap;
import java.util.concurrent.ExecutorService;
import java.util.concurrent.Executors;
import java.io.IOException;
import java.io.InputStream;
import java.nio.charset.StandardCharsets;

import anywheresoftware.b4a.keywords.Common;
import anywheresoftware.b4a.BA;
import anywheresoftware.b4a.BA.Events;
import anywheresoftware.b4a.BA.ShortName;
import anywheresoftware.b4a.BA.Version;
import anywheresoftware.b4a.IOnActivityResult;

import android.content.BroadcastReceiver;

import android.content.Intent;
import android.os.Bundle;

//import android.support.v4.app.TaskStackBuilder;
//import android.support.v7.app.AppCompatActivity;
//import android.support.v7.widget.SwitchCompat;
import android.util.Base64;
import com.google.gson.Gson;
import com.google.gson.GsonBuilder;

@Version(1.0f)
//@Permissions(values={"android.permission.INTERNET"})
@ShortName("libSIBS")


@DependsOn(values={"androidx.legacy:legacy-support-v4","com.android.support:support-fragment", "com.android.support:support-compat", "android.arch.lifecycle:common", "com.android.support:recyclerview-v7", "com.android.support:cardview-v7", "com.android.support:gridlayout-v7", "com.android.support.constraint:constraint-layout", "com.android.support:support-v4", "com.android.support:support-compat", "nexgo-sibs-sdk-v2.3.3_20200428.aar", "gson-2.8.2"})

@ActivityObject
	public class libSIBS extends AppCompatActivity  {


 	final static String SIBS = "SIBS";
    final static String BCP = "BCP";
    final static String BST = "BST";

    final static String DATA_MPOS = "DATA_MPOS";  //key with name of bundle
    final static String PACKAGE_ID = "PACKAGE_ID";  //key with caller package id
    final static String BASE64REFERENCE = "BASE64REFERENCE";  //key for base64 sent to mpos
    final static String REQUEST_RESPONSE = "RETURN_VALUE_BOOLEAN"; //key with boolean indicating if response is required
    final static String REQUEST_KEY = "REQUEST_KEY";

    final static String CALLIN_ERROR_KEY = "CALL_IN_ERROR"; //key for response field : error
    final static String CALLIN_STATUS_KEY = "CALL_IN_STATUS"; //key for response field : status
      private final int activityRequestCode = 100;
  
	public double PagamentoValor;
	public String PagamentoRef;	

	

	public void Initialize(BA ba) {
        


    }


	/** Called when the activity is first created. */
	@Override
	public void onCreate(Bundle savedInstanceState) {

		BA.Log(": onCreate");
		super.onCreate(savedInstanceState);
		//setContentView(R.layout.main);

	}

	public void FazPagamento(BA ba) {

		BA.Log(": FazPagamento");
		BA.Log("valor:" + PagamentoValor);
		BA.Log("Vou fazer o intent");
		

		 Intent launchIntent = new Intent();

		 launchIntent.setClassName("pt.sibs.android.mpos.sibsPagamentosDev", "pt.sibs.android.mpos.activities.MainActivity");
        
        TaskStackBuilder stackBuilder = TaskStackBuilder.create(this);
        stackBuilder.addNextIntent(launchIntent);

		// create a json with value and reference
        MessageToSend messageToSend = new MessageToSend();
        value = value.replaceAll("[^\\d.]", "");
        messageToSend.setAmmount(value);
        messageToSend.setReference(reference);
        Gson gson = new GsonBuilder().create();
        String message = gson.toJson(messageToSend,MessageToSend.class);
        
        //String message = "{'ammount':'0.70','reference:'OLA3'}";
		// convert json to a Base64
		byte[] bytes;
        bytes = message.getBytes(StandardCharsets.UTF_8);
        String base64msg = Base64.encodeToString(bytes, Base64.DEFAULT);
        
		// create a bundle and intent to call mpos and send data over
        Bundle data = new Bundle();
        data.putString(PACKAGE_ID, "b4x.example");
        data.putBoolean(REQUEST_RESPONSE, true);
        data.putString(BASE64REFERENCE,base64msg);
        data.putInt(REQUEST_KEY, activityRequestCode);
        launchIntent.setFlags(Intent.FLAG_ACTIVITY_SINGLE_TOP);
        launchIntent.putExtra(DATA_MPOS, data);

        // Open external APK via intent
		this.startActivityForResult(launchIntent, 100);
		
		BA.Log(": Fim FazPagamento");
		
		
	}

@Override
	public void onActivityResult(int requestCode, int resultCode,  Intent data) {
		BA.Log(": onActivityResult");

        if(requestCode == activityRequestCode) {
            String status;
            String errorCode;
            if (data != null && data.getExtras() != null) {
                errorCode = data.getExtras().getString(CALLIN_ERROR_KEY);
                status = data.getExtras().getString(CALLIN_STATUS_KEY);

                BA.Log( "STATUS2: "+status+" Error "+errorCode);
            }
        }
    }


      protected void onNewIntent(Intent intent) {
      	BA.Log(": onNewIntentt");
        String status = "";
        String errorCode = "";
		// get response from mpos
        if(intent != null && intent.getExtras() != null){
            errorCode = intent.getExtras().getString(CALLIN_ERROR_KEY);
            status = intent.getExtras().getString(CALLIN_STATUS_KEY);
        }

        BA.Log(  "STATUS1: "+status+" Error "+errorCode);
        super.onNewIntent(intent);
    }

   

}